<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Binary Image Preview</title>
</head>
<body>
    <div id="imageContainer">
        <img id="imagePreview" src="" alt="Image Preview">
    </div>

    <script>
        const imageContainer = document.getElementById('imageContainer');
        const imagePreview = document.getElementById('imagePreview');
        const socket = new WebSocket('ws://localhost:4000'); // Adjust the WebSocket URL accordingly

        socket.binaryType = 'arraybuffer'; // Set binary data type

        socket.addEventListener('open', (event) => {
            console.log('WebSocket connection opened.');
        });

        socket.addEventListener('message', (event) => {
            if (event.data instanceof ArrayBuffer) {
                // Convert ArrayBuffer to Blob
                const blob = new Blob([event.data], { type: 'image/jpeg' }); // Adjust the media type based on your image format
                console.log('Received binary image data.');

                // Set the image source and display the image
                const imageUrl = URL.createObjectURL(blob);
                imagePreview.src = imageUrl;

                // Display the image container
                imageContainer.style.display = 'block';
            }
        });

        socket.addEventListener('close', (event) => {
            console.log('WebSocket connection closed.');
        });

        socket.addEventListener('error', (event) => {
            console.error('WebSocket error:', event);
        });
    </script>
</body>
</html>
